#ifndef _CUE_H
#define _CUE_H

#include <assert.h>
#include <qobject.h>
#include <stdio.h>

class QDataStream;

class Cue
{
 public:
  
  Cue( float fadeTime = 5.0 );
  Cue( Cue& p_other );
  virtual ~Cue(); 
  
  bool serialize( QDataStream& p_os );
  bool restore( QDataStream& p_is );

  virtual void setChannel( unsigned int channel, int level );
  virtual void clearChannel( unsigned int channel );
  virtual bool channelIsSet( unsigned int channel );
  virtual int getChannel( unsigned int channel );
  
  virtual unsigned int numChannels();
  
  virtual void begin();
  virtual void next();
  
  virtual bool hasNext();
  
  virtual unsigned int currChannel();
  virtual int currLevel();
  
  virtual void setFadeTime( float fadeTime );
  virtual float fadeTime();
  
  virtual QString name();
  virtual void setName( QString& name );

  virtual float number();
  virtual void setNumber( float num );

  virtual float followTime();
  virtual void setFollowTime( float f );
  virtual void setFollow( bool b );
  virtual bool followIsSet();

  virtual Cue* jumpToCue();
  virtual void setJumpToCue( Cue* c );
  virtual bool jumpToCueIsSet();
  
  virtual int jumpTimes();
  virtual void setJumpTimes( int times ) ;

  void toascii(FILE *fp, bool percent);
  
 private:
  
  QMap<unsigned int, int> _levels;
  QMap<unsigned int, int>::iterator _it;

  QString _name;
  float _num;
  
  float _fadeTime;

  bool _follow;
  float _followTime;

  Cue* _jumpToCue;
  int _jumpTimes;
  

};

#endif //_CUE_H
