#ifndef _CUECONTROLLER_H
#define _CUECONTROLLER_H

#include <qobject.h>
#include <qptrdict.h>

#include "dmxengine.h"
#include "widgets/channelpanel.h"
#include "widgets/cuelistitem.h"
#include "cue.h"


class CueController : public QObject
{

  //TODO: HANDLE CHANGING NUMBER OF FADERS GRACEFULLY

 Q_OBJECT

 public:
 CueController( DMXEngine* engine, QListView* cueList, ChannelPanel* panel,
		QObject* parent = 0, const char* name = 0 );

  ~CueController();

  unsigned int getNumCues()
    {
      return _cues.count();
    }

  Cue* getSelectedCue();
  Cue* getCue( QListViewItem* i );

  CueListItem* getCueListItem( Cue* c );

  CueListItem* getSelectedCueListItem()
    {
      return getCueListItem( getSelectedCue() );
    }

  CueListItem* getLastCueListItem()
    {
      return static_cast<CueListItem*>(_cueList->lastItem() );
    }

  CueListItem* getFirstCueListItem()
    {
      return static_cast<CueListItem*>(_cueList->firstChild() );
    }
  
  CueListItem* newCueItem( Cue* c );
  void recordCueLevels( Cue* cue, bool allLevels = false );
  
  bool isRunning( Cue* c );
  bool isActive( Cue* c );
  
 public slots:
  
  void setLive(bool live);
  void selectedCueChanged( QListViewItem* item );  

 private:
  void setPanelView( Cue* c );

  DMXEngine* _engine;
  QListView* _cueList;
  ChannelPanel* _panel;

  QPtrDict<Cue> _cues;
  QPtrDict<CueListItem> _cueListItems;

  bool _live;
};



#endif //_CUECONTROLLER_H
