#include <sys/time.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
//static FILE *logfp;

#include "dmx.h"

#include "dmxengine.h"
#include "slight.h"


DMXEngine::DMXEngine( int argc, const char **argv )
{
  _numChannels = 0;
  _levelsBuffer = new char[512];

  const char *dmxdev = DMXdev( &argc, argv );
  _dmxout = open(dmxdev, O_WRONLY, 0);
  
  // it's the caller's responsability to check isValid()
  if( _dmxout < 0 )
      return;

  for( int i = 0; i < 512; i++ )
      _levelsBuffer[i] = 0;

  lseek(_dmxout, 0, SEEK_SET);
  write(_dmxout, _levelsBuffer, 512 );
}

DMXEngine::~DMXEngine()
{
	if(_dmxout > 0)
		close(_dmxout);
}

void DMXEngine::setLevel( unsigned int channel, int newLevel )
{
    _levelsBuffer[channel] = (unsigned char)newLevel;
}

void DMXEngine::effectLevelChange()
{

/*
	int i;
	struct timeval now;
	double dnow;
	
	if(logfp == NULL) {
		logfp = fopen("dmxengine-log", "w");
		if(logfp == NULL) {
			perror("dmxengine-log");
			exit(1);
		}
		fprintf(logfp, "time");
		for(i = 0; i < 24; i++) {
			fprintf(logfp, " d%d", i+1);
		}
		fprintf(logfp, "\n");
	}

	gettimeofday(&now, NULL);
	dnow = now.tv_sec + now.tv_usec / 1000000.0;
	
	fprintf(logfp, "%-15.3f ", dnow);
	for(i = 0; i < 24; i++) {
		fprintf(logfp, "%4u", (unsigned int)((unsigned char)_levelsBuffer[i]));
	}
	fprintf(logfp, "\n");
*/

  lseek(_dmxout, 0, SEEK_SET);
  write(_dmxout, _levelsBuffer, 512 );
}

