#ifndef _FADER_H
#define _FADER_H

#include <qobject.h>
#include <qtimer.h>
#include <qvaluelist.h>

class DMXEngine;

class Fader : public QObject
{
  Q_OBJECT

  public:
    Fader( unsigned int faderNum, DMXEngine *engine, 
            QObject *parent = 0, const char *name = 0 );
    ~Fader();

    int getLevel()  {return (int)m_level;}
    void setLevel( int level );
    
    void fadeTo( int level, float time );

    unsigned int number()
    {
        return m_faderNum;
    }

    void addChannel( unsigned int channel ) 
      {
	m_channels.append( channel );
      }
    
    void removeChannel( unsigned int channel )
      {
	m_channels.remove( channel );
      }
    
    void clearChannels()
      {
	m_channels.clear();
      }

  signals:
    void levelChanged( uint fader, int newLevel );
    

  private slots:
    void timer_tick();
  
  private:

  static const int m_faderAccuracy = 20;  //timer accuracy in msec

  unsigned int m_faderNum;
  float m_level;
    int m_targetLevel;
    float m_stepSize;
    
    QValueList<unsigned int> m_channels;

    QTimer m_timer;

    DMXEngine* m_engine;
};

#endif //_FADER_H
