#include <qapplication.h>
#include <qlayout.h>
#include <qframe.h>
#include <qpalette.h>
#include <qscrollview.h>
#include <qvbox.h>
#include <qobject.h>

#include "widgets/channelpanel.h"
#include "widgets/cuelistitem.h"
#include "cue.h"
#include "dmxengine.h"

int main( int argc, char** argv ) 
{
  QApplication a( argc, argv );
  
  QListView list;
  list.addColumn( "Cues" );
  

  Cue c(5);
  c.setName( QString("Cue 1: Hello, world!") );

  CueListItem i( &list, &c );
 
  a.setMainWidget( &list  );
  list.show();
  return a.exec();
}

int main2( int argc, char **argv )
{
  
  QApplication a( argc, argv );
  DMXEngine engine( argc, (const char**)argv );
  ChannelPanel panel;

  QObject::connect( &engine, SIGNAL( levelChanged(int, int) ),
           &panel, SLOT( setChannelLevel(int, int) ) );  
  QObject::connect( &engine, SIGNAL( numFadersChanged(int) ),
           &panel, SLOT( setNumChannels(int) ) );   

  panel.setShowPercent( true );

  Cue c(0.5);  
 
  engine.setNumFaders( 2 );
  engine.setNumChannels( 2 );
  engine.mapChannelToFader( 0, 0 );
  engine.mapChannelToFader( 1, 1 );

  c.setChannel( 0, 50 );
  c.setChannel( 1, 255 );

  QSizePolicy size_pol( QSizePolicy::Expanding,
                        QSizePolicy::Expanding, 1, 1 );
  
  panel.setSizePolicy( size_pol );

  a.setMainWidget( &panel );
  panel.show();
  engine.fadeTo( c );
  return a.exec();
}

