#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>

#include <qapplication.h>
#include <qmessagebox.h>
#include <qfile.h>
#include "mainform.h"

#include "slight.h"
#include "dmxengine.h"
#include "zerocue.h"

class MainController;

SLModel* model;
ZeroCue ZeroCue::_singleton;
MainController* controller;

int main( int argc, char ** argv )
{
    QApplication a( argc, argv );
    DMXEngine* engine = new DMXEngine( argc, (const char**)argv );

    setlinebuf(stdout);
    // a little error checking.

    if( !engine->isValid() )
    {
        QMessageBox::critical( 0, "SLight",
                QString( "Could not open the DMX4Linux device.  ") +
                "Please check your DMX4Linux installation." );
        return 1;
    }

    // and check the euid.  if it's not 0, warn.  yes, the security guys
    // will hate me for this.  but tell me how to set thread priority

    // in a safer manner and we'll look at it.

    if( geteuid() != 0 )
    {
        QMessageBox::warning( 0, "SLight",
                QString( "It is strongly recommended that you run SLight " )
                + "as an SUID process.\nFor more information, please read "
                + "the accompanying documentation." ); 
    }
    
    model = new SLModel( engine );

    mainForm *w = new mainForm;
    a.setMainWidget( w );
    w->show();
//    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );

/*
  accept name of cue file to restore on command line. not working yet.
  for ( int i = 0; i < a.argc(); i++ )  // a.argc() == argc
	    printf("arg[%d]=\"%s\"\n", i, a.argv()[i] );
    if(a.argc() >= 2) {
	    QFile f( a.argv()[1] );
	    if ( f.open(IO_ReadOnly) ) {   
		    printf("reading \"%s\"...\n", a.argv()[1] );
		    // file opened successfully
		    QDataStream s( &f );        // use a text stream
		    controller->restore(s);
		    f.close();
		    printf("done\n");
	    } else {
		    perror(a.argv()[1]);
	    }
  }
*/
    return a.exec();
}
