#ifndef _maincontrollerblind_h
#define _maincontrollerblind_h

#include "maincontroller.h"
#include "mainform.h"

class QKeyEvent;
class QPopupMenu;

class MainControllerBlind : public MainController
{

    public:
    MainControllerBlind( mainForm* form );
    ~MainControllerBlind();

    void setup();
    void teardown();

    void cueDoubleClicked( QListViewItem* p_item );
    void cueSelected( QListViewItem* p_item );

    void recordClicked();
    void recordNewClicked();

    void numFadersChanged( uint p_numFaders );
    void modelLevelChanged( uint p_fader, int p_level );
    void panelLevelChanged( uint p_fader, int p_level );

 
    void keyPressEvent( QKeyEvent* p_event );
    void keyReleaseEvent( QKeyEvent* p_event );
    void cueContextMenu( QListViewItem* item, const QPoint& pos );

    void fadeToCue( Cue *cue );

    private:
    void recordCueLevels( Cue* p_cue, bool p_allLevels );
    void setPanelView( Cue* p_cue );

    Cue* m_selectedCue;  //set at teardown, read at setup.

    QPopupMenu m_cueContextMenu;
};        

#endif
