#ifndef _maincontrollerlive_h
#define _maincontrollerlive_h

#include <qvaluevector.h>

#include "maincontroller.h"
#include "mainform.h"
#include "widgets/channel.h"

class QKeyEvent;
class QPopupMenu;

class MainControllerLive : public MainController
{

    public:
    MainControllerLive( mainForm* form );
    ~MainControllerLive();

    void setup();
    void teardown();

    void cueDoubleClicked( QListViewItem* p_item );
    void cueSelected( QListViewItem* p_item );

    void recordClicked();
    void recordNewClicked();

    void numFadersChanged( uint p_numFaders );
    void modelLevelChanged( uint p_fader, int p_level );
    void panelLevelChanged( uint p_fader, int p_level );
    
    void keyPressEvent( QKeyEvent* p_event );
    void keyReleaseEvent( QKeyEvent* p_event );
    void cueContextMenu( QListViewItem* item, const QPoint& pos );

    void fadeToCue( Cue *cue );

    private:

    void recordCueLevels( Cue* p_cue, bool p_allLevels );
    void setPanelView( Cue* p_cue );

    QValueVector<int> m_savedLevels;
    QValueVector<enum ChannelState> m_savedStates;
    QPopupMenu m_cueContextMenu;
};

#endif  //_maincontrollerlive_h
