/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/


void patchPanelForm::init()
{
    
    _channels = model->getNumChannels();
    _faders = model->getNumFaders();
    
  /*    fadersChanged(model->getNumFaders());
    channelsChanged(model->getNumChannels());
  */
    
    channelsSpin->setValue( _channels );
    fadersSpin->setValue( _faders );
    
    patchList->setSorting( -1 );
    channelList->setSorting( -1 );
    
    // populate the channels select box and channel maps.
 
    channelList->setSelectionMode( QListView::NoSelection );
    
    for( unsigned int currFader = 0; currFader < _faders; currFader++ )
    {
	QValueList<uint> newMap;
	_maps.push_back(newMap);
    }
    
    unsigned int fader;
    for( unsigned int currChan = 0; currChan < _channels; currChan++ )
    {
	new QListViewItem( channelList, channelList->lastItem(), 
			   QString::number( currChan + 1 ) );
	
	if( (model->getFaderForChannel( currChan, &fader )) == true)
	    _maps[fader].push_back(currChan);
	
    }
	
    for( unsigned int currFader = 0; currFader < _faders; currFader++ )
    {
	QString col1 = QString::number(currFader + 1);
	QString col2 = stringify( _maps[currFader] );
	
	new QListViewItem( patchList, patchList->lastItem(), col1, col2 );
    }
}

void patchPanelForm::accept()
{
    model->setNumChannels( _channels );
    model->setNumFaders( _faders );
    
    unsigned int currFader;
    for( unsigned int currChan = 0; currChan < _channels; currChan++ )
	if( model->getFaderForChannel( currChan, &currFader ) )
	    model->removeChannelMap( currChan, currFader );
    
    for( currFader = 0; currFader < _faders; currFader++ )
	for( QValueList<unsigned int>::iterator iter 
	     = _maps[currFader].begin();
                  iter != _maps[currFader].end(); iter++ )
	    model->mapChannelToFader( *iter, currFader );
    model->checkpoint();
    QDialog::accept();
}

void patchPanelForm::oneToOne()
{
    fadersChanged( _channels );
    fadersSpin->setValue(_faders);
    
    _maps.clear();
    for( unsigned int chanNum = 0; chanNum < _channels; chanNum++ )
    {
	QValueList<unsigned int> newList;
	newList.push_back( chanNum );
	_maps.push_back(newList);
    }

    for( QListViewItem* currFader = patchList->firstChild();
    currFader;
    currFader = currFader->nextSibling() )
    {
	unsigned int faderNum = currFader->text(0).toInt() - 1;
	currFader->setText( 1, stringify( _maps[faderNum] ) );
    }
	
    patchList->triggerUpdate();
}

void patchPanelForm::fadersChanged( int value )
{
    if( (uint)value > _faders )
    {
	while( _maps.count() < (uint)value)
	{
	    QValueList<uint> newMap;
	    _maps.push_back( newMap );
	    new QListViewItem( patchList, patchList->lastItem(),
			       QString::number( _maps.size() ), 
			       stringify( _maps.back() ) );
	}
    }
    else
    {
	while( _maps.count() > (uint)value )
	{
	    _maps.pop_back();
	    QListViewItem* i = patchList->lastItem();
	    patchList->takeItem( i );
	    delete i;
	}
    }
    _faders = value;
    patchList->triggerUpdate();
}

void patchPanelForm::channelsChanged( int value )
{    
    if( (uint)value > _channels )
    {
	for( int i = channelList->childCount(); i < value; i++ )
	    new QListViewItem( channelList, channelList->lastItem(), 
			       QString::number( i + 1 ) );  
    }	
    else
    {
	for( QListViewItem* item = channelList->lastItem();
	channelList->childCount() > value; 
	item = channelList->lastItem() )
	{
	    channelList->takeItem( item );
	    delete item;
	}
	
	for( unsigned int chanNum = value; 
	       chanNum < _channels; chanNum++ )
	    for( QListViewItem* currFader = patchList->firstChild();
	           currFader;
	           currFader = currFader->nextSibling() )
		   {
		       unsigned int faderNum 
			       = currFader->text(0).toInt() - 1;
		       QValueList<unsigned int>::iterator i = 
			       _maps[faderNum].find( chanNum );
		       if( i != _maps[faderNum].end() )
		       {
			   _maps[faderNum].remove( chanNum );
			   currFader->setText( 1, 
				     stringify( _maps[faderNum] ) );
		       }
		   }
	
    }
    
    channelList->triggerUpdate();
    _channels = value;
   
}

void patchPanelForm::faderSelectionChanged()
{
    QListViewItem* faderItem = patchList->selectedItem();
      
    if( faderItem != 0 )
    {
	channelList->setSelectionMode( QListView::Multi );
	
	unsigned int faderNum = faderItem->text(0).toInt() - 1;
	for( QListViewItem* currChan = channelList->firstChild();
	currChan;
	currChan = currChan->nextSibling() )
	{
	    unsigned int chanNum = currChan->text(0).toInt() - 1;
	    if( _maps[faderNum].find(chanNum) 
		!= _maps[faderNum].end() )
		currChan->setSelected(true);
	    else
		currChan->setSelected(false);
	}
    }
    else
    {
	channelList->setSelectionMode( QListView::NoSelection );
	
	for( QListViewItem* currChan = channelList->firstChild();
	currChan;
	currChan = currChan->nextSibling() )
	    currChan->setSelected(false);
    }
    
    channelList->triggerUpdate();
}

QString patchPanelForm::stringify( QValueList< uint > &v )
{
    QString ret;
    for( unsigned int j = 0; j < v.count(); j++ )
    {   
        if( ret.length() != 0 )
            ret.append(' ');
        ret.append( QString::number(v[j] + 1) );
    }
    
    return ret;
}

void patchPanelForm::channelSelectionChanged()
{
    QListViewItem* faderItem = patchList->selectedItem();
    unsigned int faderNum = faderItem->text(0).toInt() - 1;
    
    _maps[faderNum].clear();
    
    for( QListViewItem* currItem = channelList->firstChild();
	 currItem;
	 currItem = currItem->nextSibling() )
    {
	unsigned int chanNum = currItem->text(0).toInt() - 1;
	
	if( currItem->isSelected() )
	{
	    _maps[faderNum].append( chanNum );	
	    
	    for( QListViewItem* currFader = patchList->firstChild();
	    currFader;
	    currFader = currFader->nextSibling() )
	    {
		if( currFader != faderItem )
		{
		    int faderNum = currFader->text(0).toInt() - 1;
		    QValueList<unsigned int>::iterator i 
			    = _maps[faderNum].find( chanNum );
		    if( i != _maps[faderNum].end() )
		    {
			_maps[faderNum].remove( chanNum );
			currFader->setText( 1, stringify( _maps[faderNum] ) );
		    }
		}
	    }
	}
		
    }
    
    faderItem->setText( 1, stringify( _maps[faderNum] ) );
    patchList->triggerUpdate();
}


