#ifndef _RTCFADERTHREAD_H
#define _RTCFADERTHREAD_H

#include <qthread.h>
#include <qptrqueue.h>

class QMutex;
class RTCFader;
class DMXEngine;

class RTCFaderThread : public QThread
{
  public:

      RTCFaderThread( DMXEngine* m_engine );
      ~RTCFaderThread();

      void run();

      void addFader( RTCFader* p_fader );
      void checkFader( RTCFader* p_fader );

  private:
      int m_rtc; //the file descriptor
      DMXEngine* m_engine;
      QPtrQueue< RTCFader > m_faders;
      QMutex m_faderMutex;
};

#endif // _RTCFADERTHREAD_H
