#ifndef CHANNELLAYOUT_H
#define CHANNELLAYOUT_H

#include <qlayout.h>
#include <qptrlist.h>

class ChannelLayout : public QLayout
{
public:
    ChannelLayout( QWidget *parent, int dist )
        : QLayout( parent, 0, dist ) { }
    ChannelLayout( QLayout* parent, int dist )
        : QLayout( parent, dist ) { }
    ChannelLayout( int dist )
        : QLayout( dist ) { }
    ~ChannelLayout();

    void addItem(QLayoutItem *item);
    QSize sizeHint() const;
    QSize minimumSize() const;
    QLayoutIterator iterator();
        
    void setGeometry(const QRect &rect);

private:
    QPtrList<QLayoutItem> list;
};

#endif

