#include "channelpanelplugin.h"
#include "channelpanel.h"

#include <qstring.h>


QStringList ChannelPanelPlugin::keys() const
{
  QStringList list;
  list << "ChannelPanel";
  return list;
}



QWidget* ChannelPanelPlugin::create( const QString &key, QWidget* parent, const char* name )
{
  if ( key == "ChannelPanel" )
    return new ChannelPanel( parent, name );
  return 0;
}

QString ChannelPanelPlugin::includeFile( const QString& feature ) const
{
  if ( feature == "ChannelPanel" )
    return "widgets/channelpanel.h";
  return QString::null;
}

QString ChannelPanelPlugin::group( const QString& feature ) const
{
  if ( feature == "ChannelPanel" )
    return "Input";
  return QString::null;
}

QIconSet ChannelPanelPlugin::iconSet( const QString& ) const
{
  return QIconSet( QPixmap( QString( "/home/brian/mozilla/icons/mozicon16.xpm" ) ) );
  
}

QString ChannelPanelPlugin::toolTip( const QString& feature ) const
{
  if ( feature == "ChannelPanel" )
    return "Channel panel widget";
  return QString::null;
}

QString ChannelPanelPlugin::whatsThis( const QString& feature ) const
{
  if ( feature == "ChannelPanel" )
    return "A widget to change channel levels";
  return QString::null;
}


bool ChannelPanelPlugin::isContainer( const QString& ) const
{
  return FALSE;
}

Q_EXPORT_PLUGIN( ChannelPanelPlugin )
  




