#include <qpainter.h>
#include <qfont.h>
#include <qstring.h>

#include "cuelistitem.h"

#include "slight.h"
#include "slmodel.h"
#include "maincontroller.h"

CueListItem::CueListItem( Cue* cue, QListView* parent )
  : QListViewItem( parent ), m_cue( cue )
{
}

/*
CueListItem::CueListItem( Cue* cue, CueListItem* parent )
  : QListViewItem( parent ), m_cue( cue )
{
}
*/

CueListItem::CueListItem( Cue* cue, QListView* parent, QListViewItem* after )
  : QListViewItem( parent, after ), m_cue( cue )
{
}

/*
CueListItem::CueListItem( Cue* cue, QListViewItem* parent, 
                            QListViewItem* after )
  : QListViewItem( parent, after ), m_cue( cue )
{
}
*/

CueListItem::~CueListItem() 
{
}
  
    
void CueListItem::paintCell( QPainter *p, const QColorGroup &cg,
				     int column, int width, int alignment )
{
    //TODO: Indicate jump-to, follow time.
  // build the string

  QString cueText = QString( "Cue %1: %2" ).arg(m_cue->number()).arg(m_cue->name());
  
  cueText.append( QString("  Fade: %1").arg(m_cue->fadeTime()));

  if( m_cue->followIsSet() )
      cueText.append( QString( "  Follow: %1" ).arg(m_cue->followTime()) );
  if( m_cue->jumpToCueIsSet() )
 //     if( model->getNumJumps( m_cue ) != -1 )
          cueText.append( QString( "  Jump to cue %1: %2" )
                  .arg(m_cue->jumpToCue()->number())
                  .arg(model->getNumJumps(m_cue)) );
  /*    else
          cueText.append( QString( "  Jump to cue %1: %2" )
                  .arg(m_cue->jumpToCue()->number())
                  .arg(m_cue->jumpTimes()) );

*/
  setText( 0, cueText );

  QFont fontBackup = p->font();
  QColor c = cg.text();
  
  QColorGroup newCg( cg );
  QFont newFont = p->font();

  if( model->isCurrent( m_cue ) )
    newFont.setWeight( QFont::Bold );
  if( model->isRunning( m_cue ) )
    newCg.setColor( QColorGroup::Text, Qt::red );
  if( m_cue->numChannels() == model->getNumFaders() )
    newFont.setUnderline(true);

  //newFont.setFamily( "fixed" );

  p->setFont( newFont );



  QListViewItem::paintCell( p, newCg, column, width, alignment );

  p->setFont( fontBackup );
  newCg.setColor( QColorGroup::Text, c );
}

