#ifndef _zeroCUE_H
#define _zeroCUE_H

#include <assert.h>

#include <qobject.h>

#include "cue.h"
#include "slight.h"
#include "slmodel.h"

class Cue;

class ZeroCue : public Cue
{
  
 private:
  ZeroCue() : Cue(), _it(0)
    {};
 
 public:
  ~ZeroCue() {};
  
  void setChannel( unsigned int, int )
    {
    }

  void clearChannel( unsigned int )
    {
    }
  
  bool channelIsSet( unsigned int )
    {
        return true;
    }
  
  int getChannel( unsigned int )
    {
        return 0;
    }
  
  
  unsigned int numChannels()
    {
        return model->getNumFaders();
    }        
  
  void begin()
    {
        _it = 0;
    }
  
  void next()
    {
        _it++;
    }
  
  bool hasNext()
    {
      return _it < model->getNumFaders();
    }
  
  unsigned int currChannel()
    {
      return _it;
    }
  
  int currLevel()
    {
      return 0; 
    }
/*  
  void setFadeTime( float )
    {
    }
  
  float fadeTime()
    {
      return 0; 
    }
  */
  
  QString name()
    {
      return QString( "Blackout" );
    }
  
  void setName( QString& )
    {
    }

  float number()
    {
      return 0;
    }
  
  void setNumber( float )
    {
    }
/*
  float followTime()
    {
      return 0.0;
    }
  
  void setFollowTime( float )
    {
    }
  
  bool followIsSet()
    {
      return false;
    }

  Cue* jumpToCue()
    {
      return NULL;
    }
  
  void setJumpToCue( Cue* )
    {
    }
  
  bool jumpToCueIsSet()
    {
      return false;
    }
  
  int jumpTimes()
    {
      return 0;
    }
  
  void setJumpTimes( int ) 
  {
  }
*/
  static ZeroCue* singleton()
  {
      return &_singleton;
  }
  
 private:
  
    static ZeroCue _singleton;
    unsigned int _it;
};

#endif //_zeroCUE_H
